//
//  AdMobTest.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by nanomech on 18/05/2020.
//

#ifndef AdMobTest_hpp
#define AdMobTest_hpp

#include <stdio.h>
// HIVE SDK v4 UI-Helper
#include "BaseView.hpp"
#include "HIVEAdKit.hpp"

class AdMobTest : public BaseView, HIVEAdKit::EventHandlers
{
public:
    CREATE_FUNC(AdMobTest);

    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    

private:
    enum : int {
        BUTTON_INIT_ADMOB,
        BUTTON_INIT_REWARDED_VIDEO,
        BUTTON_LOAD_REWARDED_VIDEO,
        BUTTON_SHOW_REWARDED_VIDEO,
        BUTTON_INIT_INTERSTITIAL_AD,
        BUTTON_LOAD_INTERSTITIAL_AD,
        BUTTON_SHOW_INTERSTITIAL_AD,
        BUTTON_ADAPTIVE_BANNER_POSITION,
        BUTTON_INIT_ADAPTIVE_BANNER,
        BUTTON_LOAD_ADAPTIVE_BANNER,
        BUTTON_SHOW_ADAPTIVE_BANNER,
        BUTTON_HIDE_ADAPTIVE_BANNER,
    };
public:
    
    HIVEAdKit::RewardVideo* rewardVideo;
    HIVEAdKit::Interstitial* interstitial;
    HIVEAdKit::AdaptiveBanner* adaptiveBanner;
    firebase::admob::BannerView::Position bannerPosition;
    
    virtual void onAdLoaded() override;
    virtual void onAdOpening() override;
    virtual void onAdClosed() override;
    virtual void onUserEarnedReward(std::string type, double amount) override;
    virtual void onAdLeavingApplication() override;
//    virtual void onRewardedVideoAdOpened() override;
//    virtual void onRewardedVideoStarted()override;
//    virtual void onRewarded()override;
//    virtual void onRewardedVideoCompleted()override;
//    virtual void onRewardedVideoAdClosed()override;

};

#endif /* AdMobTest_hpp */
